<?php

namespace Bushelpowered\Api\Platform\Eventstore\Common;

class EventContent
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'text' => null,
        'base64' => null,
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Text(string $data): EventContent
    {
        return new EventContent('text', $data);
    }
    public static function Base64(string $data): EventContent
    {
        return new EventContent('base64', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    